package org.gcn.plinguacore.simulator;

import org.gcn.plinguacore.util.PlinguaCoreException;
/**
 * An interface to get information about class name providers for available simulators
 * 
 *  @author Research Group on Natural Computing (http://www.gcn.us.es)
 *
 */
public interface ISimulatorClassProvider extends ISimulatorInfo{

	

	
	
	/**
	 * Returns an iterator on the simulators which support alternative step
	 * @return  an iterator on the simulators which support alternative step
	 */
	 
	public Class<?>[] getAlternativeStepSupportedSimulators();
	

	/**
	 * Returns the name of the class which implements the simulator required by id and which provides the extra functionality appointed by typeId
	 * @param id the id of the required simulator
	 * @param typeId the id of the type of simulator required
	 * @return the name of the class which implements the simulator
	 * @throws PlinguaCoreException if the simulator required doesn't exists
	 */
	public String idClassName(String id, String typeId)
	throws PlinguaCoreException;
}
