package org.gcn.plinguacore.util.check;

import java.util.ArrayList;
import java.util.List;



public class BaseCheck<T> implements InnerCheck<T> {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -3685134922361847876L;
	private List<String> causes;
	private boolean initializedCauses = false;

	/**
	 * Creates a new BaseCheckRule instance
	 */
	public BaseCheck() {
		super();
		causes = new ArrayList<String>();
	}

	/**
	 * @see org.gcn.plinguacore.util.psystem.rule.checkRule.CheckRule#checkRule(org.gcn.plinguacore.util.psystem.rule.Rule)
	 */
	@Override
	public boolean check(T obj) {
		// TODO Auto-generated method stub
		// ;
		initializedCauses = false;
		return true;
	}

	/**
	 * @see org.gcn.plinguacore.util.psystem.rule.checkRule.CheckRule#getCauses()
	 */
	public List<String> getCauses() {
		return causes;
	}

	/**
	 * @see org.gcn.plinguacore.util.psystem.rule.checkRule.CheckRule#getCausesString()
	 */
	public String getCausesString() {
		String str = "";
		for (int i = 0; i < causes.size(); i++) {
			str += "    " + causes.get(i);
			if (i < causes.size() - 1)
				str += "\n";
		}
		return str;
	}

	/* (non-Javadoc)
	 * @see util.psystem.rule.checkRule.InnerCheckRule#initializedCauses()
	 */
	public boolean initializedCauses() {
		// TODO Auto-generated method stub
		return initializedCauses;
	}


	/* (non-Javadoc)
	 * @see util.psystem.rule.checkRule.InnerCheckRule#initCauses()
	 */
	public void initCauses() {
		initializedCauses = true;

	}

}
