package org.gcn.plinguacore.util.psystem.checkPsystem.specificCheckPsystem;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.gcn.plinguacore.simulator.cellLike.probabilistic.ProbabilisticPsystemFactory;
import org.gcn.plinguacore.util.Pair;
import org.gcn.plinguacore.util.psystem.ActivationSets;
import org.gcn.plinguacore.util.psystem.Psystem;
import org.gcn.plinguacore.util.psystem.cellLike.CellLikePsystem;
import org.gcn.plinguacore.util.psystem.checkPsystem.CheckPsystem;
import org.gcn.plinguacore.util.psystem.checkPsystem.DecoratorCheckPsystem;
import org.gcn.plinguacore.util.psystem.rule.Rule;
import org.gcn.plinguacore.util.psystem.rule.cellLike.ConstantCellLikeRule;

public class CompleteProbabilities extends DecoratorCheckPsystem implements CheckPsystem {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8921870457272723574L;
	private List<Rule> causeRules=null;
	
	
	public CompleteProbabilities() {
		super();
		// TODO Auto-generated constructor stub
	}
	public CompleteProbabilities(CheckPsystem cr) {
		super(cr);
		// TODO Auto-generated constructor stub
	}
	@Override
	protected boolean checkSpecificPart(Psystem p) {
		// TODO Auto-generated method stub
		causeRules=null;
		if (!(p instanceof CellLikePsystem))
			return true;
		Map<ActivationSets,List<Rule>>map = ProbabilisticPsystemFactory.getRulesByActivationSet((CellLikePsystem)p);
		Iterator<List<Rule>>it = map.values().iterator();
		while(it.hasNext())
		{
			List<Rule>list=it.next();
			float sum=0;
			Iterator<Rule>it1=list.iterator();
			while(it1.hasNext() && sum<=1)
			{
				Rule r = it1.next();
				float pr=((ConstantCellLikeRule)r).getConstant();
				sum+=pr;
				
				
			}
			
			if (sum>1.0001 || sum<0.9999)
			{
				causeRules=list;
				return false;
			}
		}
		return true;
	}
	private String getCauseRules()
	{
		String str="";
		if (causeRules!=null)
		{
			Iterator<Rule>it=causeRules.iterator();
			while(it.hasNext())
			{
				Rule r = it.next();
				str+=r.toString();
				if (it.hasNext())
					str+="\n";
			}
		}
		return str;
	}

	@Override
	protected String getSpecificCause() {
		// TODO Auto-generated method stub
		if (causeRules==null)
			return "The summming of probabilities of rules with the same left-hand side must be 1";
		else
		
			return "The probabilities of the following set of rules (with same left-hand side) are not summing 1:\n"+getCauseRules();
		
		
	}

}
