package org.gcn.plinguacore.util.psystem.checkPsystem.specificCheckPsystem;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.gcn.plinguacore.simulator.cellLike.probabilistic.ProbabilisticPsystemFactory;
import org.gcn.plinguacore.util.Pair;
import org.gcn.plinguacore.util.psystem.ActivationSets;
import org.gcn.plinguacore.util.psystem.Psystem;
import org.gcn.plinguacore.util.psystem.cellLike.CellLikePsystem;
import org.gcn.plinguacore.util.psystem.checkPsystem.CheckPsystem;
import org.gcn.plinguacore.util.psystem.checkPsystem.DecoratorCheckPsystem;
import org.gcn.plinguacore.util.psystem.rule.InnerRuleMembrane;
import org.gcn.plinguacore.util.psystem.rule.Rule;
import org.gcn.plinguacore.util.psystem.rule.cellLike.ConstantCellLikeRule;

public class ConsistentRules extends DecoratorCheckPsystem {

	private List<Rule> causeRules=null;
	public ConsistentRules() {
		super();
		// TODO Auto-generated constructor stub
	}

	public ConsistentRules(CheckPsystem cr) {
		super(cr);
		// TODO Auto-generated constructor stub
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = -3213988448397373493L;

	@Override
	protected boolean checkSpecificPart(Psystem p) {
		// TODO Auto-generated method stub
		causeRules=null;
		if (!(p instanceof CellLikePsystem))
			return true;
		Map<ActivationSets,List<Rule>>map = ProbabilisticPsystemFactory.getRulesByActivationSet((CellLikePsystem)p);
		
		Iterator<List<Rule>>it = map.values().iterator();
		while(it.hasNext())
		{
			boolean unconsistent=false;
			List<Rule>list=it.next();
			Map<String,Byte> map1 = new HashMap<String,Byte>();
			Iterator<Rule>it1=list.iterator();
			while(it1.hasNext() && !unconsistent)
			{
				Rule r = it1.next();
					
					
				String label=r.getRightHandRule().getOuterRuleMembrane().getLabel();
				byte ch =r.getRightHandRule().getOuterRuleMembrane().getCharge();
				if (map1.containsKey(label))
				{
					byte ch1=map1.get(label);
					if (ch1!=ch)
						unconsistent=true;
				}
				else
					map1.put(label,ch);
				Iterator<InnerRuleMembrane>it2 = r.getRightHandRule().getOuterRuleMembrane().getInnerRuleMembranes().iterator();
				while(it2.hasNext())
				{
					InnerRuleMembrane irm=it2.next();
					label=irm.getLabel();
					ch =irm.getCharge();
					if (map1.containsKey(label))
					{
						byte ch1=map1.get(label);
						if (ch1!=ch)
							unconsistent=true;
					}
					else
						map1.put(label,ch);
				
				}
			}
			if (unconsistent)
			{
				causeRules=list;
				return false;
			}
			
		}
		return true;
	}

	private String getCauseRules()
	{
		String str="";
		if (causeRules!=null)
		{
			Iterator<Rule>it=causeRules.iterator();
			while(it.hasNext())
			{
				Rule r = it.next();
				str+=r.toString();
				if (it.hasNext())
					str+="\n";
			}
		}
		return str;
	}
	@Override
	protected String getSpecificCause() {
		// TODO Auto-generated method stub
		if (causeRules==null)
			return "There are rules with unconsistent charges";
		else
		
			return "The following set of rules has unconsistent charges:\n"+getCauseRules();
		
	}

}
